/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */

package org.diacalc.mobile.maths;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */
import java.util.Vector;
import com.sun.lwuit.*;
import com.sun.lwuit.layouts.BorderLayout;
import com.sun.lwuit.geom.Dimension;


public class Str {
    public static  Vector split(String st,String div){
        Vector res = new Vector();
        int start = 0;
        int pos = 0;
        while(pos<st.length()){
            pos = st.indexOf(div, start);
            if (pos>=0){
                res.addElement(st.substring(start, pos));
                start = pos + div.length();
            }
            else break;
        }
        res.addElement(st.substring(start, st.length()));
        return res;
    }
    public static float pow(float v,int p){
        if (p<=0) return 1f;
        float res = v;
        for(int i=0;i<(p-1);i++){
            res *= v;
        }
        return res;
    }
    public static float round(float v,int z){
        return (float)(int)((v+ 0.5f/pow(10f,z)  )* pow(10.0f,z)) /  pow(10.0f,z);
    }
    /*public static  int round(float v){
       return (int)(v+0.5f);
    }
    public static float round0(float v){
       return (float)(int)((v+0.05f)*10.0f)/10.0f;
    }
    public static float round00(float v){
       //round to 2 decimal points
       //double number = (double)(int)((bmi+0.005)*100.0)/100.0;
       //round to 4 decimal points
       //double number = (double)(int)((bmi+0.00005)*10000.0)/10000.0;
       return (float)(int)((v+0.005f)*100.0f)/100.0f;
    }*/
    public static Vector getFirstTagged(String output, String tag) throws Exception{
        Vector strs = new Vector();
        String tagfullst = "<"+tag+">";
        String tagfullend = "</"+tag+">";
        int st = 0;
        int end = 0;
        while (output.length()>0 && st>=0 && end>=0){
            st = output.indexOf(tagfullst);
            end = output.indexOf( tagfullend, st+tagfullst.length());
            if (st>=0 && end>=0){
                strs.addElement(output.substring(st+tagfullst.length(), end));
                output = output.substring(end+tagfullend.length());
            }
            else new Exception("no needed tag "+tag+" found");
        }
        return strs;
    }
    
    public static String URLencode(String s){
        StringBuffer sbuf = new StringBuffer();
        int len = s.length();
        for (int i = 0; i < len; i++) {
          int ch = s.charAt(i);
          if ('A' <= ch && ch <= 'Z') {		// 'A'..'Z'
            sbuf.append((char)ch);
          } else if ('a' <= ch && ch <= 'z') {	// 'a'..'z'
            sbuf.append((char)ch);
          } else if ('0' <= ch && ch <= '9') {	// '0'..'9'
            sbuf.append((char)ch);
          } else if (ch == ' ') {			// space
            sbuf.append('+');
          } else if (ch <= 0x007f) {		// other ASCII
            sbuf.append(hex[ch]);
          } else if (ch <= 0x07FF) {		// non-ASCII <= 0x7FF
            sbuf.append(hex[0xc0 | (ch >> 6)]);
            sbuf.append(hex[0x80 | (ch & 0x3F)]);
          } else {					// 0x7FF < ch <= 0xFFFF
            sbuf.append(hex[0xe0 | (ch >> 12)]);
            sbuf.append(hex[0x80 | ((ch >> 6) & 0x3F)]);
            sbuf.append(hex[0x80 | (ch & 0x3F)]);
          }
        }
        return sbuf.toString();
   }
   final static String[] hex = {
    "%00", "%01", "%02", "%03", "%04", "%05", "%06", "%07",
    "%08", "%09", "%0a", "%0b", "%0c", "%0d", "%0e", "%0f",
    "%10", "%11", "%12", "%13", "%14", "%15", "%16", "%17",
    "%18", "%19", "%1a", "%1b", "%1c", "%1d", "%1e", "%1f",
    "%20", "%21", "%22", "%23", "%24", "%25", "%26", "%27",
    "%28", "%29", "%2a", "%2b", "%2c", "%2d", "%2e", "%2f",
    "%30", "%31", "%32", "%33", "%34", "%35", "%36", "%37",
    "%38", "%39", "%3a", "%3b", "%3c", "%3d", "%3e", "%3f",
    "%40", "%41", "%42", "%43", "%44", "%45", "%46", "%47",
    "%48", "%49", "%4a", "%4b", "%4c", "%4d", "%4e", "%4f",
    "%50", "%51", "%52", "%53", "%54", "%55", "%56", "%57",
    "%58", "%59", "%5a", "%5b", "%5c", "%5d", "%5e", "%5f",
    "%60", "%61", "%62", "%63", "%64", "%65", "%66", "%67",
    "%68", "%69", "%6a", "%6b", "%6c", "%6d", "%6e", "%6f",
    "%70", "%71", "%72", "%73", "%74", "%75", "%76", "%77",
    "%78", "%79", "%7a", "%7b", "%7c", "%7d", "%7e", "%7f",
    "%80", "%81", "%82", "%83", "%84", "%85", "%86", "%87",
    "%88", "%89", "%8a", "%8b", "%8c", "%8d", "%8e", "%8f",
    "%90", "%91", "%92", "%93", "%94", "%95", "%96", "%97",
    "%98", "%99", "%9a", "%9b", "%9c", "%9d", "%9e", "%9f",
    "%a0", "%a1", "%a2", "%a3", "%a4", "%a5", "%a6", "%a7",
    "%a8", "%a9", "%aa", "%ab", "%ac", "%ad", "%ae", "%af",
    "%b0", "%b1", "%b2", "%b3", "%b4", "%b5", "%b6", "%b7",
    "%b8", "%b9", "%ba", "%bb", "%bc", "%bd", "%be", "%bf",
    "%c0", "%c1", "%c2", "%c3", "%c4", "%c5", "%c6", "%c7",
    "%c8", "%c9", "%ca", "%cb", "%cc", "%cd", "%ce", "%cf",
    "%d0", "%d1", "%d2", "%d3", "%d4", "%d5", "%d6", "%d7",
    "%d8", "%d9", "%da", "%db", "%dc", "%dd", "%de", "%df",
    "%e0", "%e1", "%e2", "%e3", "%e4", "%e5", "%e6", "%e7",
    "%e8", "%e9", "%ea", "%eb", "%ec", "%ed", "%ee", "%ef",
    "%f0", "%f1", "%f2", "%f3", "%f4", "%f5", "%f6", "%f7",
    "%f8", "%f9", "%fa", "%fb", "%fc", "%fd", "%fe", "%ff"
   };

   private final static MathEvaluator evaluter = new MathEvaluator();

   private final static String numb = "1234567890.+-*/()";
   private final static String nodouble = ".+-*/";

   public static float parseString(TextField row,int zeros){
        String st = row.getText().trim();
        if (st.length()==0) return 0f;
        String st1="";
        //удаляем все неиспользуемые символы
        for(int i=0;i<st.length();i++){
            for(int j=0;j<numb.length();j++){
                if (st.charAt(i)==numb.charAt(j)){
                    st1 += st.charAt(i);
                    break;
                }
            }
        }
        //Двойные символы так же надо убрать
        if (st1.length()>1){
            int i=0;
            boolean found = false;
            while (i<(st1.length()-1)){
                found = false;
                if (st1.charAt(i)==st1.charAt(i+1)){
                    for(int j=0;j<nodouble.length();j++){
                        if (st1.charAt(i)==nodouble.charAt(j)){
                            //Удаляем
                            st1 = st1.substring(0, i) + st1.substring(i+1);
                            found = true;
                            break;
                        }
                    }
                }
                if (!found) i++;
            }
        }

        //считаем скобки
        int c=0;
        int a=0;
        for(int i=0;i<st1.length();i++){
            if (st1.charAt(i)=='(') c++;
            if (st1.charAt(i)==')') a++;
        }
        if (c>a){//Добавляем в конец ) скобки
            for(int i=0;i<(c-a);i++){
                st1 += ')';
            }
        }
        else if (c<a){//Добавляем в начало ( скобки
            for(int i=0;i<(a-c);i++){
                st1 = '(' + st1;
            }
        }
        float res;
        evaluter.setExpression(st1);
        try{
            res = evaluter.getValue().floatValue();
        }
        catch(Exception ex){
            res = 0f;
        }
        res = res>0?res:0f;

        String strR = ""+Str.round(res, zeros);
        int p = strR.indexOf(".");
        if (zeros==0){
            strR = strR.substring(0, p);
        }else{//проверяем достаточность знаков после запятой
            int l = strR.length()-p - 1; //0.12 - 2 = 2  0.123 -2 = 3
            //кол-во знаков после запятой
            // 1.1    // 1 до десят части длина 3 - после запят 1
            // 0.11   // 1 до десят части длина 4 - после запятой 2
            // 15.123 // 2 до десят части длина 6 - после запятой 3
            for(int i=0;i<(zeros-l);i++){
                strR += "0";
            }
        }
        row.setText(strR);
        return res;
    }
    public static String extendZero(int v){
        return v<10?("0"+v):(""+v);
    }
    public static String replace(String src,String frst,String scd){
        //Ищем вхождение first и меняем его на scd
        int i = -1;
        String res = src;
        while(  (i=res.indexOf(frst))>=0 ){
            res = res.substring(0, i) + scd + res.substring(i+frst.length());
        }
        return res;
    }
    /**
     * Helper method that allows us to create a pair of components label and the given
     * component in a horizontal layout with a minimum label width
     */
    public static Container createPair(String label, Component c, int minWidth) {
        Container pair = new Container(new BorderLayout());
        Label l =  new Label(label);
        l.setAlignment(Label.RIGHT);
        Dimension d = l.getPreferredSize();
        d.setWidth(Math.max(d.getWidth(), minWidth));
        l.setPreferredSize(d);
        pair.addComponent(BorderLayout.WEST,l);
        pair.addComponent(BorderLayout.CENTER, c);
        return pair;
    }

      /**
     * Helper method that allows us to create a pair of components label and the given
     * component in a horizontal layout
     */
     public static Container createPair(String label, Component c) {
         return createPair(label,c,0);
     }
}
